// /ORDERTRIES:1024 /COMPMODE:SLOW

#define WIN32_LEAN_AND_MEAN
#define WIN32_EXTRA_LEAN
#include <windows.h>
#include <mmsystem.h>
#include "../../intro.h"
#include "../../mzk.h"
#include "../../intro.h"

int wavHeader[11] = {
    0x46464952, 
    MZK_NUMSAMPLES*2+36, 
    0x45564157, 
    0x20746D66, 
    16, 
    WAVE_FORMAT_PCM|(MZK_NUMCHANNELS<<16), 
    MZK_RATE, 
    MZK_RATE*MZK_NUMCHANNELS*sizeof(short), 
    (MZK_NUMCHANNELS*sizeof(short))|((8*sizeof(short))<<16),
    0x61746164, 
    MZK_NUMSAMPLES*sizeof(short)
    };

PIXELFORMATDESCRIPTOR pfd =
    {
    sizeof(PIXELFORMATDESCRIPTOR),
    1,
    PFD_DRAW_TO_WINDOW|PFD_SUPPORT_OPENGL|PFD_DOUBLEBUFFER,
    PFD_TYPE_RGBA,
    32,
    0, 0, 0, 0, 0, 0, 8, 0,
    0, 0, 0, 0, 0,
    32, 0, 0,
    PFD_MAIN_PLANE,
    0, 0, 0, 0
    };

short myMuzik[MZK_NUMSAMPLES+22];


extern "C" int _fltused = 0;

//#include <GL/gl.h>
void entrypoint( void )
{              
#if 1
    HWND hWnd = CreateWindow( "static", 0, WS_POPUP|WS_VISIBLE|WS_MAXIMIZE, 0, 0, 0 , 0, 0, 0, 0, 0);
#else
    HWND hWnd = CreateWindow( "static", "rgba :: kinderplomber", WS_POPUP|WS_VISIBLE|WS_MAXIMIZE|SS_CENTER|SS_CENTERIMAGE, 0, 0, 0 , 0, 0, 0, 0, 0);
    SendMessage( hWnd, WM_SETFONT, (WPARAM)CreateFont(44,0,0,0,0,0,0,0,0,0,0,ANTIALIASED_QUALITY,0,"tahoma"), TRUE );
#endif
	HDC  hDC  = GetDC( hWnd );         
    SetPixelFormat( hDC, ChoosePixelFormat(hDC, &pfd), &pfd );
	wglMakeCurrent( hDC, wglCreateContext(hDC) );

	ShowCursor( 0 );  

    #if 0
        glClearColor( 0.0f, 0.0f, 0.0f, 0.0f );
        glClear( GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT );
        wglSwapLayerBuffers( hDC, WGL_SWAP_MAIN_PLANE );
    #endif


	// init intro
	intro_init();

	// calculate music
	mzk_init( myMuzik+22 );

	// and play it 
    memcpy( myMuzik, wavHeader, 44 );
    sndPlaySound( (const char*)&myMuzik, SND_ASYNC|SND_MEMORY );

    long t;
	long to = timeGetTime();
    do 
	{
        t = timeGetTime(); 
        //if( !to ) to=t; 
        t = t-to;//-150;
    
        intro_do( t );
    
        //SwapBuffers ( hDC );   
        wglSwapLayerBuffers( hDC, WGL_SWAP_MAIN_PLANE );
	}while ( !GetAsyncKeyState(VK_ESCAPE) && t<(MZK_DURATION*1000) );

    sndPlaySound(0,0);

    ExitProcess(0);
}

