//--------------------------------------------------------------------------//
// iq . 2003 . code for the Paradise 64 kb intro by RGBA                    //
//--------------------------------------------------------------------------//

#ifndef _TYPES_H_
#define _TYPES_H_


//-----------------------------------
// 8, 16, 32 and 64 bit types
//-----------------------------------

typedef unsigned long   uint32;
typedef   signed long   sint32;
typedef unsigned short  uint16;
typedef   signed short  sint16;
typedef unsigned char   uint8;
typedef   signed char   sint8;


#ifdef WINDOWS
 typedef __int64     	        sint64;
 typedef unsigned __int64       uint64;
#endif

#ifdef IRIX
 typedef   signed long          sint64;
 typedef unsigned long          uint64;
#endif

#ifdef LINUX
 #ifdef A64BITS
  typedef   signed long          sint64;
  typedef unsigned long          uint64;
 #else
  typedef          long long int sint64;
  typedef unsigned long long int uint64;
 #endif

#endif

//-----------------------------------
// integer pointer
//-----------------------------------

#ifdef A32BITS
    typedef uint32 intptr;
#endif
#ifdef A64BITS
    typedef uint64 intptr;
#endif


//-----------------------------------
// inlines, alignmensts...
//-----------------------------------

#ifdef WINDOWS
    #ifdef __cplusplus
    #define INTROSYS_INLINE  __forceinline
    #else
    #define INTROSYS_INLINE
    #endif
    #define INTROSYS_ALIGN16 __declspec(align(16))
#else
    #define INTROSYS_ALIGN16 __attribute__ ((aligned(16))) 
    #define INTROSYS_INLINE  inline
#endif


#endif
